# -*- coding: utf-8 -*-
from irc3.plugins.command import command
import irc3

@irc3.plugin
class Plugin(object):
  def __init__(self, bot):
    self.bot = bot
    self.channel = '#botshop'
    self.played = {}

  def show_win(self, winner, winner_choice, loser, loser_choice):
    self.bot.privmsg(self.channel, '%s has beaten %s\'s %s with %s.' % (winner, loser, loser_choice, winner_choice))
    self.played = {}

  def show_draw(self, first_player, second_player, choice):
    self.bot.privmsg(self.channel, '%s and %s have both played %s and drew.' % (first_player, second_player, choice))
    self.played = {}
    
  @command(permission='view', public=False)
  def rock(self, mask, target, args):
    """Play rock
       %%rock
    """
    if self.played == {}:
      self.bot.privmsg(self.channel, '%s has played!' % mask.nick)
      self.played = {'nick': mask.nick, 'choice': 'rock'}
    elif self.played['choice'] == 'scissors':
      self.show_win(mask.nick, 'rock', self.played['nick'], 'scissors')
    elif self.played['choice'] == 'paper':
      self.show_win(self.played['nick'], 'paper', mask.nick, 'rock')
    elif self.played['choice'] == 'rock':
      self.show_draw(self.played['nick'], mask.nick, 'rock')
      
  @command(permission='view', public=False)
  def paper(self, mask, target, args):
    """Play paper
       %%paper
    """
    if self.played == {}:
      self.bot.privmsg(self.channel, '%s has played!' % mask.nick)
      self.played = {'nick': mask.nick, 'choice': 'paper'}
    elif self.played['choice'] == 'rock':
      self.show_win(mask.nick, 'paper', self.played['nick'], 'rock')
    elif self.played['choice'] == 'scissors':
      self.show_win(self.played['nick'], 'scissors', mask.nick, 'paper')
    elif self.played['choice'] == 'paper':
      self.show_draw(self.played['nick'], mask.nick, 'paper')

  @command(permission='view', public=False)
  def scissors(self, mask, target, args):
    """Play scissors
       %%scissors
    """
    if self.played == {}:
      self.bot.privmsg(self.channel, '%s has played!' % mask.nick)
      self.played = {'nick': mask.nick, 'choice': 'scissors'}
    elif self.played['choice'] == 'paper':
      self.show_win(mask.nick, 'scissors', self.played['nick'], 'paper')
    elif self.played['choice'] == 'rock':
      self.show_win(self.played['nick'], 'rock', mask.nick, 'scissors')
    elif self.played['choice'] == 'scissors':
      self.show_draw(self.played['nick'], mask.nick, 'scissors')
